/*qXeVX𓱓traZT[@made by takefuji
Jan. 1 2008*/

#include <usb.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#define VENDOR_ID   0x1384		 /*VID must be changed. */
#define PRODUCT_ID  0x8888		 /*PID must be changed. */
#define interval    1		 /* every interval time temperature measured */

static int usbOpenDevice(usb_dev_handle **device, int idvendor, int idproduct)
{
	struct usb_bus *bus;
	struct usb_device *dev;
	usb_dev_handle *udh=NULL;
	int ret,retp, retm,errors;
	char string[256];

	usb_init();
	ret=usb_find_busses(); 
	retp=usb_find_devices(); if(ret!=retp){return errors=1;} 
	for (bus = usb_busses; bus; bus = bus->next)
	{
		for (dev = bus->devices; dev; dev = dev->next)
		{
			udh=usb_open(dev);
			retp = usb_get_string_simple(udh, dev->descriptor.iProduct, string, sizeof(string));
			retm=usb_get_string_simple(udh, dev->descriptor.iManufacturer, string, sizeof(string));
			if (retp > 0 && retm > 0)
				if (idvendor==dev->descriptor.idVendor && idproduct==dev->descriptor.idProduct){ *device=udh;return errors=0;}
		}
	}
	usb_close(udh);return errors=1;
}


int main(int argc, char **argv)
{
	usb_dev_handle *d=NULL;
	unsigned char buffer[1], sensed;
	int i,j,th=0,LH=0;
	int mode, ret;
	char *buf;
	time_t t;
	if(argc<2){printf("you need temperature data\n");return 0;}
	j=atoi(argv[1]);

	for(;;)
	{
	mode=0;i=0;
	ret=usbOpenDevice(&d,VENDOR_ID,PRODUCT_ID);
	if(ret!=0){ printf("Plugin your USB device%d \n",ret); return 0;}
	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN, mode, i, 0, (char *)buffer, sizeof(buffer), 5000);
		sensed=buffer[0]/2;
printf("sensed data %d\n",sensed);
		LH=th;
		if(sensed >= j) {th=1;mode=1;i=0xff;}
		if(sensed <= j-2) {th=0;mode=0;i=0;}
/***** you must change the email address of xxx@yyy:reply address, zzz mail server, ddd@eee destination address *****/
	if(LH==0 && th==1){
	sprintf(buf,"/bin/email -s 'sensed temperature is over '%s%s",argv[1]," -n xxx@yyy -r mail.server ddd@eee -b ");
system(buf);
		ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN, mode, i, 0, (char *)buffer, sizeof(buffer), 5000);
}
		if(sensed < j-1) {mode=1;i=0;
		ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN, mode, i, 0, (char *)buffer, sizeof(buffer), 5000);
}
		sleep(1);}
	return 0;
}
