/*date:nov. 1, 2007 by takefuji
tiny2313 for gps UBRR=12MHz/(16*4800) -1=155.25 311.5*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include "usbdrv.h"

static uchar fifo[50];
static uchar pointer;

ISR(USART_RX_vect) 
{ uchar c=UDR;
	if(c=='$') {pointer=0;}
	else 
{	fifo[pointer]=c; pointer++; 
	if(pointer>=50){pointer=0;}
		}
}


uchar usbFunctionSetup(uchar data[8])
{
static uchar replybuf[8];
    
    usbMsgPtr = replybuf;

    if(data[1] == 0){
	replybuf[0]=fifo[0];
	replybuf[1]=fifo[1];
	replybuf[2]=fifo[2];
	replybuf[3]=fifo[3];
	replybuf[4]=fifo[4];
	replybuf[5]=fifo[5];
	replybuf[6]=fifo[6];
	replybuf[7]=fifo[7];
	
	return 8;	}
    if(data[1] == 1){
	replybuf[0]=fifo[8];
	replybuf[1]=fifo[9];
	replybuf[2]=fifo[10];
	replybuf[3]=fifo[11];
	replybuf[4]=fifo[12];
	replybuf[5]=fifo[13];
	replybuf[6]=fifo[14];
	replybuf[7]=fifo[15];
	sei();
	return 8;	}
    
	return 0;
}


int main(void)
{
	UBRRH=1;
	UBRRL=55;
	UCSRA=0x02;
	UCSRB=(1<<RXEN)|(1<<RXCIE);
	UCSRC=0x6;
	pointer=0;
  usbInit();
  sei();
  for(;;){	        /* main event loop */
    	usbPoll();
	  }
  return 0;
}
