/*date:nov. 1, 2007 by takefuji
tiny2313 for gps UBRR=12MHz/(16*4800) -1=155.25 if U2X=0
UBRR=12MHz/(8*4800)-1=311.5=256+55.5 if U2X=1*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include "usbdrv.h"

static uchar rmc[50];
uchar mode=4;
int pointer=0;

ISR(USART_RX_vect) 
{ uchar c=UDR;
if(mode==4 && c=='R'){mode=0;rmc[0]=c;pointer=1;}
else if(mode==0 && c!='*'){rmc[pointer]=c;pointer++;
		if(pointer==49)mode=4;}
}

uchar usbFunctionSetup(uchar data[8])
{
static uchar replybuf[8];
    
    usbMsgPtr = replybuf;

    if(data[1] == 0){
	replybuf[0]=rmc[0+data[2]*8];
	replybuf[1]=rmc[1+data[2]*8];
	replybuf[2]=rmc[2+data[2]*8];
	replybuf[3]=rmc[3+data[2]*8];
	replybuf[4]=rmc[4+data[2]*8];
	replybuf[5]=rmc[5+data[2]*8];
	replybuf[6]=rmc[6+data[2]*8];
	replybuf[7]=rmc[7+data[2]*8];
	return 8;	}
	return 0;
}

int main(void)
{
	UBRRH=0;
	UBRRL=155;
	UCSRA=0x00;	//U2X=0
	UCSRB=(1<<RXEN)|(1<<RXCIE);
	UCSRC=0x6;
  usbInit();
  sei();
  for(;;){	        /* main event loop */
    	usbPoll();
	  }
  return 0;
}
