/*
*/

#include <usb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#define VENDOR_ID   0x1384		 /*VID must be changed. */
#define PRODUCT_ID  0x8888		 /*PID must be changed. */

static int usbOpenDevice(usb_dev_handle **device, int idvendor, int idproduct)
{	struct usb_bus *bus;
	struct usb_device *dev;
	usb_dev_handle *udh=NULL;
	int retp, retm,errors;
	char string[256];
	usb_init();
	retp=usb_find_busses();
	retm=usb_find_devices();if(retp!=retm){return errors=2;}
	for (bus = usb_busses; bus; bus = bus->next)
	{
		for (dev = bus->devices; dev; dev = dev->next)
		{	udh=usb_open(dev);
			retp = usb_get_string_simple(udh, dev->descriptor.iProduct, string, sizeof(string));
			retm=usb_get_string_simple(udh, dev->descriptor.iManufacturer, string, sizeof(string));
			if (retp > 0 && retm > 0)
				if (idvendor==dev->descriptor.idVendor && idproduct==dev->descriptor.idProduct){ *device=udh;return errors=0;}
		}
	}
				 usb_close(udh);return errors=1;
}

int main(int argc, char **argv)
{	usb_dev_handle *d=NULL;
	unsigned char c,buffer[8];
	int i,j,mode,ret;
	FILE *fp;
	time_t t;
	mode=0;i=0;
		ret=usbOpenDevice(&d,VENDOR_ID,PRODUCT_ID);
        	if(ret!=0){ printf("plugin your USB device. %d \n",ret); return 0;}  
		ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN, mode, i, 0, (char *)buffer, sizeof(buffer), 5000);
printf("%d%s",10*(buffer[4]-48)+buffer[5]-48+9 % 24, " : ");
for(j=6;j<8;j++)
printf("%c",buffer[j]);
printf(" : ");
		mode=0;i=1;
		ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN, mode, i, 0, (char *)buffer, sizeof(buffer), 5000);
for(j=0;j<2;j++)
printf("%c",buffer[j]);
printf("\n");
}
