/* 
designed by takefuji on sept.1, 2007 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include "usbdrv.h"

void delay(unsigned int p)
{
  unsigned char i;        
  unsigned char j;	 //one loop is 3.8us with 12MHz
  for(i=0;i<p;i++)
    for(j=0;j<10;j++);
}


uchar usbFunctionSetup(uchar data[8])
{
static uchar replybuf[8];	
usbMsgPtr = replybuf;

if((data[1] )==0){
	DDRA=  (DDRA | 0x7c);	//PA6-PA2 output, PA7 PA0-1 input
	DDRA= (DDRA & 0x7f);
	PORTA = data[2];
	DDRB=  (DDRB & 0x0d);	//PB1 input
	replybuf[0] = PINB ;
	replybuf[1] = PINA ;
	return 2;
	}

return 0;
  	
}

int main(void)
{
	DDRA=  (DDRA | 0x7c);	//PA6-PA2 output, PA7 PA0-1 input
	DDRA= (DDRA & 0x7f);
	DDRB=  (DDRB & 0x0d);	//PB1 input
	PORTA= 0x00;

  usbInit();
  sei();

  for(;;){		// main event loop
    	usbPoll();
	  }
  return 0;
}
